import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.sql.SQLException;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class Janela extends JFrame{
	private Fachada fachada;
	private JTextField campoCpf;
	private JButton botaoConsulta;
	private JPanel imgPanel;
	private BufferedImage foto;
	private JLabel labelNome;
	private JButton botaoAddFoto;
	private String nome;
	
	public Janela() {
		super("Consulta Oracle");
		try {
			fachada = new Fachada();
			this.init();
		} catch (SQLException e) {
			mostrarErro(e);
			this.dispose();
		} catch (ClassNotFoundException e) {
			mostrarErro(e);
			this.dispose();
		} catch (IOException e){
			mostrarErro(e);
			this.dispose();
		}
	
	}
	public void mostrarErro(Exception  e){
		JOptionPane.showMessageDialog(this, e.getMessage());
	}
	public void init() throws IOException{
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.labelNome = new JLabel("");
		this.imgPanel = new JPanel();
		this.campoCpf = new JTextField(11);
		this.botaoConsulta = new JButton("Procura");
		this.botaoAddFoto = new JButton("Atualiza Foto");
	
		Container container = this.getContentPane();
		container.setLayout(new FlowLayout());
		container.add(this.imgPanel);
		container.add(this.campoCpf);
		container.add(botaoAddFoto);
		container.add(this.botaoConsulta);
		container.add(this.labelNome);

		this.pack();
		
		this.setVisible(true);
		this.botaoConsulta.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
				botaoConsultaAction();
			}
			
		});

		this.botaoAddFoto.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0){
				botaoAddFotoAction();
			}
		});
		
		this.addWindowListener(new WindowListener(){

			@Override
			public void windowActivated(WindowEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowClosed(WindowEvent arg0) {
				System.out.println("FECHOU");
				try {
					fachada.close();
				} catch (SQLException e) {
					mostrarErro(e);
				}
				
			}

			@Override
			public void windowClosing(WindowEvent arg0) {
				System.out.println("FECHOU");
				try {
					fachada.close();
				} catch (SQLException e) {
					mostrarErro(e);
				}
				
			}

			@Override
			public void windowDeactivated(WindowEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowDeiconified(WindowEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowIconified(WindowEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowOpened(WindowEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});
		
	}
	public void atualizaImagem(){
		this.imgPanel.removeAll();
		if(foto != null){
			JLabel pic = new JLabel(new ImageIcon(foto));
			this.imgPanel.add(pic);
		}
		this.labelNome.setText(nome);
		//this.repaint();
	}
	public void botaoAddFotoAction(){
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new File("E:/users/Igor/workspace/GDI-multimidia"));
		int retorno = fc.showOpenDialog(this);
		if(retorno == JFileChooser.APPROVE_OPTION){
			if(!this.campoCpf.getText().equals("")){
				try {
					fachada.atualizaImagem(fc.getSelectedFile(), this.campoCpf.getText());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		botaoConsultaAction();
	}
	public void botaoConsultaAction() {
		if(this.campoCpf.getText().equals("")){
			System.out.println("O campo est vazio");
		}else{
			try {
				fachada.fazConsulta(this.campoCpf.getText());
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			this.foto = fachada.getFoto();
			this.nome = fachada.getNome();
			atualizaImagem();
		}
		
	}
	public static void main(String[] args) throws SQLException, IOException {
		Janela j = new Janela();
	}
}
